// SCI Recive prog. from H8/3048F AD Convert to Temperature aplication.
//                                      (c)2009.3.10.  MI-TAKE/tminobe
//
//  2009.3.12. V1.1.3 1st release
//  2009.3.14. V1.2.1 ADD AutoStret
//  2009.3.20. V1.2.2 react AVR mega164
//  2009.7.23. V1.3.1 react app.config,csv separeter choice / VS#2005=>VS#2008

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Text.RegularExpressions;
using System.Timers;

namespace H8TempRec31
{
    public partial class Form1 : Form
    {
        static string CRLF = "\x0d\x0a";
        string h8Request = "T" + CRLF;         //RequestCommandInterval
        string h8RequestNow = "S" + CRLF;      //RequestCommandNow
        DateTime ExpireTime = new DateTime();
        static int minV, secV;
        int useInitFileF;       //use init file
        static int cntMax;

        public Form1()
        {
            InitializeComponent();

            serialPort1.BaudRate = Properties.Settings.Default.boudRate;
            serialPort1.DataBits = Properties.Settings.Default.dataBits;
            serialPort1.Handshake = Properties.Settings.Default.handShake;
            serialPort1.Parity = Properties.Settings.Default.parity;
            serialPort1.PortName = Properties.Settings.Default.portName;
            serialPort1.StopBits = Properties.Settings.Default.stopBits;
            minV = Properties.Settings.Default.minV;
            secV = Properties.Settings.Default.secV;
            cntMax = Properties.Settings.Default.cntMax;
            useInitFileF = Properties.Settings.Default.useInitFileF;
            csvChar = Properties.Settings.Default.csvChar; if (csvChar != ",") csvChar = " "; //J}ȊOSPu
        }

        private void checkSCI()
        {                                       //if will not open, then open
            if (serialPort1.IsOpen == false)    //SCI double open check
            {
                try { serialPort1.Open(); }
                catch
                {
                    MessageBox.Show("G[IʐMp[^A|[gԂmFĂ", "com-port error!!",
                         MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    timer1.Enabled = false;
                    dispTimer();
                    textBox4.Text = " ~";
                }
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            if (useInitFileF == 1)
                checkBox1.Checked = true;
            checkSCI();
            dispTimer();
            if (checkBox1.Checked == true)
                initFileRead();
            else
            {
                numericUpDown2.Value = secV;
                numericUpDown1.Value = minV;
                numericUpDown3.Value = cntMax;
            }
            if (csvChar == ",") radioButton2.Checked = true;
            else radioButton1.Checked = true;
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            serialPort1.Close();
        }
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            Properties.Settings.Default.boudRate = serialPort1.BaudRate;
            Properties.Settings.Default.dataBits = serialPort1.DataBits;
            Properties.Settings.Default.handShake = serialPort1.Handshake;
            Properties.Settings.Default.parity = serialPort1.Parity;
            Properties.Settings.Default.portName = serialPort1.PortName;
            Properties.Settings.Default.stopBits = serialPort1.StopBits;
            Properties.Settings.Default.portName = serialPort1.PortName;
            Properties.Settings.Default.secV = secV;
            Properties.Settings.Default.minV = minV;
            Properties.Settings.Default.useInitFileF = useInitFileF;
            Properties.Settings.Default.cntMax = cntMax;
            Properties.Settings.Default.csvChar = csvChar;
            Properties.Settings.Default.Save();
        }

        delegate void setTextCallback(string text);
        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {                                   //SCI recive
            if (serialPort1.BytesToRead > 2)
                SetReciveData(serialPort1.ReadLine());
        }

        private void numericUpDown1_ValueChanged_1(object sender, EventArgs e)
        {
            try
            {
                minV = (int)numericUpDown1.Value;
                dispTimer();
            }
            catch
            {
                MessageBox.Show("00b̐ݒ͏o܂ !!",
                            "H8TempRec31 Error!!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                numericUpDown2.Value = 1;
            }

        }

        private void numericUpDown2_ValueChanged_1(object sender, EventArgs e)
        {
            try
            {
                secV = (int)numericUpDown2.Value;
                dispTimer();
            }
            catch
            {
                MessageBox.Show("00b̐ݒ͏o܂ !!",
                            "H8TempRec31 Error!!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                numericUpDown2.Value = 1;
            }
        }

        private void SetReciveData(String str)
        {
            string strTempre;
            if (this.textBox1.InvokeRequired)
            {
                String pattern = "\r|\n";
                Regex rgx = new Regex(pattern);
                str = rgx.Replace(str, "");
                setTextCallback d = new setTextCallback(SetReciveData);
                this.Invoke(d, new object[] { str });
            }
            else
            {
                strTempre = str.Remove(0, 1);    //command char delete
                if (str.IndexOf("T") >= 0)        //interval data ?
                {
                    textBox1.AppendText("cnt="+csvChar + cnt.ToString("##0").PadLeft(3)
                      + csvChar + strTempre + csvChar + "" + csvChar + nowTime + CRLF);
                    textBox3.Text = "CountNo=" + cnt.ToString() + CRLF;
                }
                else
                    if (str.IndexOf("S") >= 0)       //singl request?
                        textBox6.Text = strTempre + " ";
            }
        }

        static int intervalTime = 5;
        private void dispTimer()
        {
            string str;
            intervalTime = minV * 60 + secV;
            str = " ̊ԊuF " + minV.ToString("#0") + " "
                        + secV.ToString("#0") + " bB@ ";
            str += "  I̐ݒ F" + cntMax.ToString() + "";
            str += " (" + (cntMax * intervalTime).ToString("#,#") + "b)";
            textBox2.Text = str;
            timer1.Interval = intervalTime * 1000;
        }


        string startTime, stopTime, nowTime, startDateTime;
        private void button2_Click(object sender, EventArgs e)
        {
            checkSCI();
            button2_Click_sub();
        }

        private void button2_Click_sub()
        {
            DateTime dt = DateTime.Now;
            if (cntMax == 0)
            {
                serialPort1.Write(h8Request);
                nowTime = dt.ToLongTimeString();
                button2.Text = "X^[g";
                textBox4.Text = " ~";
                textBox4.ForeColor = Color.White;
                textBox4.BackColor = Color.DarkOliveGreen;
            }
            else
            {
                if (button2.Text == "X^[g")
                {
                    cnt = 0;

                    timer1.Enabled = true;
                    ExpireTime = DateTime.Now;
                    TimeSpan stepTime = new TimeSpan(0, minV, secV);
                    ExpireTime = ExpireTime.Add(stepTime);
                    startTime = "start:" + dt.ToString();
                    startDateTime = dt.ToLongDateString() + dt.ToShortTimeString();
                    nowTime = dt.ToLongTimeString();
                    textBox3.Clear();
                    textBox3.Text = "RequNo=0 " + CRLF;
                    serialPort1.Write(h8Request);
                    button2.Text = "Xgbv";
                    textBox4.Text = "蒆";
                    textBox4.BackColor = Color.PeachPuff;
                    textBox4.ForeColor = Color.DarkRed;
                    timer1.Interval = intervalTime * 1000;
                    this.Text = "H8xc[";
                }
                else
                    stopMeasurement();
            }
        }

        static int cnt = 0;
        private void timer1_Tick(object sender, EventArgs e)
        {
            DateTime dt = DateTime.Now;
            TimeSpan et = ExpireTime.Subtract(dt);
            if (cnt >= cntMax)
                stopMeasurement();
            else
            {
                serialPort1.Write(h8Request);
                nowTime = dt.ToLongTimeString();
                cnt++;
            }
        }

        private void stopMeasurement()
        {
            DateTime dt = DateTime.Now;
            timer1.Enabled = false;
            stopTime = "stop:" + dt.ToString();
            button2.Text = "X^[g";
            if (autoStartFlg == 1) autoFileSave();@@//**autoStartFlg = 1;
            {
                textBox4.Text = " ~";
                textBox4.ForeColor = Color.White;
                textBox4.BackColor = Color.DarkOliveGreen;
            }
            autoStartFlg = 0;
        }

        private string editFilePath = "";  //edit file path 
        private void OtĕۑSToolStripMenuItem1_Click(object sender, EventArgs e)
        { //timeX^vŐVKt@C\
            DateTime dt = DateTime.Now;
            string savefName = dt.ToLongDateString() + dt.ToShortTimeString();
            string fName = "\\" + savefName.Replace(':', '') + "";
            editFilePath = System.IO.Directory.GetCurrentDirectory() + fName + ".txt";
            string fileNameString = GetFileNameString(editFilePath, '\\');

            saveFileDialog1.FileName = fileNameString;
            saveFileDialog1.ShowDialog(this);
        }

        private void saveFileDialog_FileOk(object sender, CancelEventArgs e)
        {                                   //save text file
            const string MSGBOX_TITLE = "Otĕۑ";
            editFilePath = saveFileDialog1.FileName;
            try
            {
                File.WriteAllText(editFilePath, (startTime + ", " + stopTime + CRLF + textBox2.Text
                   + CRLF + textBox3.Text + CRLF + textBox1.Text + CRLF + "EOF"), Encoding.Default);
                //@this.Text = GetFileNameString(editFilePath, '\\');
                this.Text = "H8xc[:ۑ";
            }
            catch (Exception ex)
            {
                MessageBox.Show(this, ex.Message, MSGBOX_TITLE, MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private string GetFileNameString(string filePath, char separateChar)
        {                       //***open file name                   
            try
            {
                string[] strArray = filePath.Split(separateChar);
                return strArray[strArray.Length - 1];
            }
            catch
            { return ""; }
        }


        private void button1_Click(object sender, EventArgs e)
        {
            textBox1.Clear();
            dispTimer();
        }

        private void numericUpDown3_ValueChanged(object sender, EventArgs e)
        {
            cntMax = (int)numericUpDown3.Value;
            dispTimer();
        }

        private void gUToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            Help.ShowHelp(this, "H8TempRec3.chm");
        }

        private void button3_Click(object sender, EventArgs e)
        {
            try
            {
                checkSCI();
                serialPort1.Write(h8RequestNow);
            }
            catch
            {
                MessageBox.Show("ʐMp[^mFĂ", "com-port error!!",
                     MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void o[WAToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            VersionForm ver = new VersionForm();
            ver.ShowDialog();
        }
        private void IXToolStripMenuItem1_Click(object sender, EventArgs e)
        {
            serialPort1.Close();
            Close();
        }

        static int autoStartFlg = 0;
        private void initFileRead()
        {
            string strAutoST = "";
            try
            {
                StreamReader fp = new StreamReader(System.IO.Directory.GetCurrentDirectory() + "\\H8TempRec.ini");
                string strMinV = fp.ReadLine();
                string strSecV = fp.ReadLine();
                string strCntMax = fp.ReadLine();
                strAutoST = fp.ReadLine();
                System.Diagnostics.Debug.WriteLine("iniFile=" + strMinV + "," + strSecV + "," + strCntMax + "," + strAutoST);

                try
                {
                    minV = Convert.ToInt32(strMinV);
                    if ((minV < 0) || (minV > 60)) minV = 0;
                    numericUpDown1.Value = minV;
                    secV = Convert.ToInt32(strSecV);
                    if (minV > 0)
                        if ((secV < 0) || (minV > 59)) secV = 5;
                        else
                            if ((secV < 1) || (minV > 59)) secV = 5;

                    numericUpDown2.Value = secV;
                    cntMax = Convert.ToInt32(strCntMax);
                    if ((cntMax < 0) || (cntMax > 999)) cntMax = 100;
                    numericUpDown3.Value = cntMax;
                }
                catch
                {
                    MessageBox.Show("ݒFile̋Lq܂",
                            "H8TempRec31 Error!!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
                fp.Close();
            }
            catch { }
            if (strAutoST == "AUTO")
            {
                autoStartFlg = 1;
                button2_Click_sub();
            }
        }

        private void autoFileSave()
        {                       //\tg̃JgfNgɏ
            string fName = "\\" + startDateTime.Replace(':', '') + "";
            editFilePath = System.IO.Directory.GetCurrentDirectory() + fName + ".txt";
            try
            {
                /* MessageBox.Show("t@Cɕۑ܂"+editFilePath,
                     "saveAutoSave", MessageBoxButtons.OK, MessageBoxIcon.Exclamation); */
                File.WriteAllText(editFilePath, (startTime + ", " + stopTime + CRLF + textBox2.Text
                   + CRLF + textBox3.Text + CRLF + textBox1.Text + CRLF + "EOF"), Encoding.Default);
                /*@this.Text = GetFileNameString(editFilePath, '\\');@*/
                this.Text = "H8xc[:ۑ";
            }
            catch
            {
                MessageBox.Show("ۑt@C쐬o܂",
                        "save Error!!", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
        }

        private void ʐMݒSToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (timer1.Enabled == true)
                button2_Click_sub();
            serialPort1.Close();
            SerialPropertyDialog ps = new SerialPropertyDialog();@//CX^X
            ps.settingpropertyGrid.SelectedObject = serialPort1;    //serialPort1w
            ps.ShowDialog();
            ps.Dispose();   //CX^Xj
            checkSCI();
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked == true)
                useInitFileF = 1;
            else
                useInitFileF = 0;
        }

        private void menuStrip1_ItemClicked(object sender, ToolStripItemClickedEventArgs e)
        {
        }

        string csvChar;
        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            csvChar = " ";
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            csvChar = ",";
        }

    }
}